
#include <giac/giac.h>
#include "Polytope.h"
#include "Util.h"
#include "string"

using namespace std;
using namespace giac;

context ct;

int main(int argc, char *argv[]){

  MAX_COMMON_ALG_EXT_ORDER_SIZE = 200;
  MAX_ALG_EXT_ORDER_SIZE = 200;

  //  to get giac debug information:
  //  debug_infolevel = 1;

  //  gbasis_reinject_ratio=1.0;

  //  _srand(time(NULL),&ct);
  
  if (argc==2) {
    
    string stest(argv[1]); 
    cout << "Testing group " << stest <<endl;
    Polytope F = Polytope(stest);
    F.createGroup();
    F.startAlgo();    
    //  F.isArithmetic();
    
  }
  else {

    cout << "spocheck (c) 2019 Martin Deraux, Institut Fourier" << endl;
    cout << " version 1.0, licence GPL 3" << endl;
    cout << "" << endl;
    cout << "Please key in the string describing the triangle group you want to study" << endl;
    cout << "  enter   6s1      for Sporadic(6,sigma_1)" << endl;
    cout << "          t4E2     for Thompson(4,E_2)" << endl;
    cout << "          m5-7%10  for Mostow(5,7/10)" << endl;

    //  string stest = "6s4c";
    string stest;
    cin >> stest;
    
    cout << "Testing group " << stest <<endl;
    Polytope F = Polytope(stest);    
    F.createGroup();
    F.startAlgo();
    
  }
  
  return 0;
}
